var param = new Array();
var callLoginCnt; // ログインエントリが連続に2回呼ばれる対策
var getEnvRetryCnt; // env.xml読み込みでリトライ回数

var App = {
    initialize: function() {
		PGLog.writeWithTime("App.initialize start");
    	// パラメータを受け取る
    	if(window.location.search.length > 0)
    	{
			var i;
			var node;
			var temp_params = window.location.search.substring(1).split('&');
			
			for(i = 0; i < temp_params.length; i++)
			{
				node = temp_params[i].split('=');
				param[node[0]] = node[1];
			}
		}

        App.bindEvents();
		PGLog.writeWithTime("App.initialize end");
    },
    bindEvents: function() {
		PGLog.writeWithTime("App.bindEvents start");
		// スプラッシュフェード
	  	if((typeof param !== 'undefined') && (param.hasOwnProperty("boot_url")) && (param !== null)){
	  		// 起動時でない
			jQuery(document).ready(function(){
				// 背景、ロゴを隠す
				jQuery('#splash_logo').hide();
				jQuery('#splash_background').hide();
			});
		} else {
	  		// 起動時
			jQuery(document).ready(function(){
				// ロゴをフェードイン
				jQuery('#splash_logo').show();
				// 5秒後に
				setTimeout(function(){
					// 背景、ロゴをフェードアウト
					jQuery('#splash_logo').hide();
					jQuery('#splash_background').hide();
				},5000);
			
			});
		}
		
		// インジケータ表示
		Indicator.beginLoadPage();
		
        document.addEventListener('deviceready', this.onDeviceReady, false);
        document.addEventListener("backbutton", onBackKeyDown, false); // バックキー
		PGLog.writeWithTime("App.bindEvents end");
    },
    onDeviceReady: function() {
		PGLog.writeWithTime("App.onDeviceReady start");
    	getEnvRetryCnt = 0;
    	
		//App.onAppInitialize();
		decEnc.init(App.onAppInitialize);
		PGLog.writeWithTime("App.onDeviceReady end");
    },
    loadContent: function(url,param,save_undo){
		PGLog.timeList = {};		// 初期化
		PGLog.writeWithTime("App.loadContent start");
    	AppContent.onLoadContent(url,param);
		PGLog.writeWithTime("App.loadContent end");
    },
    onAppInitialize: function(){
		PGLog.writeWithTime("App.onAppInitialize start");
    	onAppInitialize();
		PGLog.writeWithTime("App.onAppInitialize end");
    },
    checkExistConnectSetting: function(env_name_key){
		PGLog.writeWithTime("App.checkExistConnectSetting start");
    	checkExistConnectSetting(env_name_key);
		PGLog.writeWithTime("App.checkExistConnectSetting end");
    },
    getEnvNameFromSharedPref: function(env_name){
		PGLog.writeWithTime("App.getEnvNameFromSharedPref start");
    	getEnvNameFromSharedPref(env_name);
		PGLog.writeWithTime("App.getEnvNameFromSharedPref end");
    },
	enableBackKey: true		// バックキー可否フラグ
};

/**
 * 環境情報取得・ブラウザの情報レンダリング
 */
function onAppInitialize(){
	PGLog.write("-------------onAppInitialize--------------");
	callLoginCnt = 0;
	
	// 接続先情報確認
	var preferences_version = PGLocalStorage.getVal('preferences_version');
	PGLog.write("onAppInitialize.preferences_version : " + preferences_version);
	
	// 初回  →  preferences_version = null、次回  →  preferences_version = chiyorozuixa
	if((preferences_version === null) || (preferences_version !== 'chiyorozuixa')) {
		// Debugで環境切り替えのときに、ローカルストレージにpreferences_versionが存在しない場合はこちらで設定します。
		// preferences_versionを変更しないかぎる、こちらの設定は問題ない
		PGLocalStorage.setVal('preferences_version'	,'chiyorozuixa');
	}
	
	PGConfig.findKeyInSharedPreferences('env_name',App.checkExistConnectSetting);
	
	// ブラウザからのイベント監視
	PGEventListener.createMessageListener();

    // ブラウザのコンテンツ表示まわりの初期化
	AppContent.onAppContentInit();

	// アプリの停止・復帰イベント監視
	PGEventListener.createPauseListener();
	PGEventListener.createResumeListener();

	// ローカルサーバの起動
	pGLocalHttpd.checkServerRunning();

	// 音声再生設定、コンテンツプレロード
	jQuery(window).load(function(){
		setTimeout(soundManager.initSettingPlayScene, 0);
		if (pGLocalHttpd.enableLocalHttpd) setTimeout(AppContent.preLoadResources, 0);
	});
}

/** 
 * 接続先情報確認
 */
function checkExistConnectSetting(env_name_key){
	PGLog.write("checkExistConnectSetting.env_name_key : " + env_name_key);
	
	if(env_name_key == 'env_name'){
		PGConfig.getStr('env_name',App.getEnvNameFromSharedPref);
	}else{
		if((typeof param !== 'undefined') && (param.hasOwnProperty("boot_url")) && (param !== null)){
			onAppDataInitialize(null);
		}else{
			// 環境情報取得
			getEnvInfo(onAppDataInitialize);
		}
	}
}

/**
 * SharedPrefから環境識別名取得
 */
function getEnvNameFromSharedPref(env_name){
	PGLog.writeWithTime("App.getEnvNameFromSharedPref start");
	PGLog.write("getEnvNameFromSharedPref : " + env_name);
	
	PGLocalStorage.setVal('env_name',env_name);
	
	PGLog.write(param);
	
	if((typeof param !== 'undefined') && (param.hasOwnProperty("boot_url")) && (param !== null)){
		// Flash演出から戻るとき、環境情報取得を行わない
		onAppDataInitialize(null);
	}else{
		// 環境情報取得
		getEnvInfo(onAppDataInitialize);
	}
	PGLog.writeWithTime("App.getEnvNameFromSharedPref end");
}

 /**
  * 環境情報取得 (config/env.xmlから)
  */
 function getEnvInfo(callback){
	PGLog.writeWithTime("App.getEnvInfo start");
 	// 環境識別名
 	var env_name = null;
 	
 	PGLog.write("-------getEnvInfo-------");
 	
 	jQuery.ajax({
        url: 'config/env.xml',
        type: 'GET',
        dataType: 'xml',
        error: function(xhr,status,err){
			PGLog.write('getEnvInfoErr: '+status+':'+err);
			
			// リトライ回数は３回まで
			if(getEnvRetryCnt <= 3){
				// エラー発生の場合
				getEnvRetryCnt = getEnvRetryCnt + 1;
				
				onAppInitialize();
			} else {
				PG_Dialog.dialogAppInitFail();
			}
			
        },
        success: function(xml){
        	// 読み込み成功 
        	jQuery(xml).find('env_name').each(function(){
        		var connect_env_str = PGLocalStorage.getVal('env_name');
        		PGLog.write("connect_env_str : " + connect_env_str );
        		
	            if((typeof connect_env_str !== 'undefined') && connect_env_str !== null){
					env_name = connect_env_str;
					PGLog.write("ローカルストレージの環境変数を使う.Env_name : "+env_name);
	            	
	            }else{
	            	env_name = jQuery(this).text();
					PGLog.write("xmlファイルの環境変数を使う.Env_name : "+env_name);
					
	            }
				
				// 環境設定情報取得
			 	jQuery(xml).find(env_name).each(function(){
			 		var axi_server_url = jQuery("axi_server_url",this).text();
			 		var axi_resource_url = jQuery("axi_resource_url",this).text();
			 		var payment_environment = jQuery("payment_environment",this).text();
			 		var sdk_environment 	= jQuery("sdk_environment",this).text();
			        var preferences_version = jQuery("preferences_version",this).text();
			        var bridge_api_endpoint = jQuery("bridge_api_endpoint",this).text();
			        var bridge_support_url 	= jQuery("bridge_support_url",this).text();
			        var gcm_sender_id		= jQuery("gcm_sender_id",this).text();
			        var client_version		= jQuery("client_version",this).text();
			        
			        var env_info = {
			        				'axi_server_url':axi_server_url,
			        				'axi_resource_url':axi_resource_url,
			        				'sdk_environment':sdk_environment,
			        				'payment_environment':payment_environment,
			        				'preferences_version':preferences_version,
			        				'bridge_api_endpoint':bridge_api_endpoint,
			        				'bridge_support_url':bridge_support_url,
			        				'gcm_sender_id':gcm_sender_id,
			        				'client_version':client_version,
			        			}
			        
			        callback(env_info);
			    });
	        });
        }
    });
	PGLog.writeWithTime("App.getEnvInfo end");
 }

/*
 * アプリにアクセスしたら、この関数を呼び出し
 */
 function onAppDataInitialize(env_info){
	 PGLog.writeWithTime("App.onAppDataInitialize start");
  	var purchase_data_str = PGLocalStorage.getVal('payment_finish_retry_purchase_data');
  	var connect_env_str = PGLocalStorage.getVal("env_name");
  	
  	if((typeof param !== 'undefined') && (param.hasOwnProperty("boot_url")) && (param !== null)){
		PGLog.write("boot_paramが存在している");
	 	//ページ訪問履歴をロード
	 	AppPageHistory.loadPageHistory();

	}else if((typeof purchase_data_str !== 'undefined') && purchase_data_str !== null){
		PGLog.write("前回の入金処理が完了していない");

	 	//ページ訪問履歴をロード
	 	AppPageHistory.loadPageHistory();
	 	
		// 前回の購入でなんらかの原因でサーバーに送信失敗の場合はこちらで送信する
	 	var purchase_data_str = PGLocalStorage.getVal('payment_finish_retry_purchase_data');
 		var purchase_data =	JSON.parse(purchase_data_str); // stringからJsonに変換
 		var axi_server_url = PGLocalStorage.getVal('axi_server_url');
		var request_url = axi_server_url + "/YappShops/updateAndroidCoinDeposit";
		ServerInquire.postData(request_url,purchase_data,PGPurchase.storePaymentFinish);
	 	
	}else{
  		PGLog.write("アプリ通常起動です。ローカルストレージの情報削除");

	 	//ページ訪問履歴を初期化
	 	AppPageHistory.clearPageHistory();
  		
	 	// ローカルストレージ削除（アプリ起動のみ）
	 	PGLocalStorage.clearAll([decEnc.keyPassphrase, decEnc.storagePassphrase]);
	 	
	 	// ローカルストレージに保存情報
	 	PGLocalStorage.setVal('axi_server_url'		,	env_info.axi_server_url);
	 	PGLocalStorage.setVal('axi_resource_url'	,	env_info.axi_resource_url);
	 	PGLocalStorage.setVal('payment_environment'	,	env_info.payment_environment);
	 	PGLocalStorage.setVal('sdk_environment'		,	env_info.sdk_environment);
	 	PGLocalStorage.setVal('preferences_version'	,	env_info.preferences_version);
	 	PGLocalStorage.setVal('bridge_api_endpoint'	,	env_info.bridge_api_endpoint);
	 	PGLocalStorage.setVal('bridge_support_url'	,	env_info.bridge_support_url);
	 	PGLocalStorage.setVal('gcm_sender_id'		,	env_info.gcm_sender_id);
	 	PGLocalStorage.setVal('client_version'		,	env_info.client_version);
	 	
	 	PGLog.write("client_version:" + env_info.client_version);
	 	
	 	//ローカル通知の許可。とりあえずここで設定。あとでちゃんと保存する
	 	PGLocalStorage.setVal('stamina_local_notification'	,	true );
	 	PGLocalStorage.setVal('musou_local_notification'	,	true );
	 	
	 	// デバイスタイプ platform_typeId : 1=iOS / 2=Android
	 	var platform = window.device.platform;
		var platform_typeId;
	 	if (platform.match(/iPhone/)) {
	 		platform_typeId = 1;
	 	}else{
	 		platform_typeId = 2; 		
	 	}
	 	PGLocalStorage.setVal('platform_typeId'	,	platform_typeId);


	}
	
	// 音声マネージャの初期化
	//soundManager.init();
	setTimeout(soundManager.init, 0);

	// ネットワーク接続状態をチェックする。OKであれば、ログイン処理へ飛ぶ
	checkNetworkConnectionState();
	PGLog.writeWithTime("App.onAppDataInitialize end");
 }

/**
 * ネットワーク接続状態チェック
 */
function checkNetworkConnectionState(){
	PGLog.writeWithTime("App.checkNetworkConnectionState start");
 	PGNetworkInfomation.getNetworkState(
 		function(result)
 		{
			if((result == Connection.UNKNOWN) || (result == Connection.NONE))
 			{//不明かつながっていない
 				//ダイアログで警告
				PG_Dialog.open_dialog(
					function(result)
					{
			         	PGLog.write("notconnecting ：" + result);
			         	navigator.App.exitApp();
					},
					"ネットワークに繋がっていません。\n回線に繋げてからアプリを起動してください。",
					"ネットワークエラー",
					["OK"]
				);
			 				
			}else{
				//　繋がっている場合はログイン処理へ飛ぶ
				//　何らかの原因でAppLoginのloginEntry関数が連続に2回呼ばれるので、callLoginCntでチェック
				// (AppのonAppInitialize関数は1回のみ呼ばれていることを確認しました)
				if(callLoginCnt == 0){
					callLoginCnt = 1;
		 			AppLogin.loginEntry();
		 		}
		 	}
 		},
         function(errs){
 			
         	//機内モードだとここにすら来ない
			PGLog.write("Fail to connect open?: "+ errs);
			PG_Dialog.open_dialog(
				function(result)
				{
		         	PGLog.write("notconnecting ：" + result);
		         	navigator.App.exitApp();
				},
				"ネットワーク状態が取得できません。",
				"ネットワークエラー",
				["OK"]
			);
         }
 	);
	PGLog.writeWithTime("App.checkNetworkConnectionState end");
}

/**
 * 端末のバックキーが押される
 */
function onBackKeyDown() {
	var url = AppPageHistory.reload_url;
	url = url.replace(/\/index\/?$/, '');// index除去

	if (App.enableBackKey == false) {
		// 戻りつつフルリロードさせる
		// 現在位置がTOPなら問答無用でアプリトップ
		if (url === '/' || url === '/yapp_homes' || url === '/homes') {
			location.href = "index.html";
		} else {
			AppPageHistory.backHistory(true);
		}
	} else {
		// 現在位置がTOPなら終了
		if (url === '/' || url === '/yapp_homes' || url === '/homes') {
			//navigator.app.exitApp();
			return;
		}

		AppPageHistory.backHistory();
	}

}
