/**
 * ClipboardManagerPlugin wrapper
 * @see https://github.com/jacob/ClipboardManagerPlugin/tree/master/v3.0.0
 * @constructor
 */
var AppClipboard = function(){};

/**
 * クリップボードへコピー
 *
 * @param str
 * @param success
 * @param fail
 */
AppClipboard.prototype.copy = function(str, success, fail) {
	if(typeof success === 'undefined') {
		success = function(result){
			PGLog.write("clipboard copy is successful : " + str);
		};
	}
	if(typeof fail === 'undefined') {
		fail = function(error){
			PGLog.write("clipboard paste is fail : " + error);
		};
	}

	clipboard.copy(str, success, fail);
};

/**
 * クリップボードから取得してcallbackを実行
 *
 * @param success
 * @param fail
 */
AppClipboard.prototype.paste = function(success, fail) {
	if(typeof fail === 'undefined') {
		fail = function(error){
			PGLog.write("clipboard paste is fail : " + error);
		};
	}

	clipboard.paste('', success, fail);
};

if (appClipboard == null) {
	var appClipboard = new AppClipboard();
}