/**
 * アプリ内設定操作クラス
 * @ref pg_config.js, pg_local_storage.js
 * @constructor
 */
var AppConfig = function(){};

AppConfig.prototype.getConfig = function(key, usePreferences) {
	if(typeof usePreferences === 'undefined') usePreferences = true;

	var _key = key;
	var value = PGLocalStorage.getVal(_key);
	if (usePreferences) {
		if (value == null) {
			PGConfig.isExistKey(_key, function(retKey) {
				if (_key == retKey) {
					PGConfig.getStr(retKey, function(retValue){
						value = retValue;
						PGLocalStorage.setVal(_key, retValue);
					});
				}
			});
		}
		PGLog.write("appConfig/getConfig:" + _key + " / " + value);
	}
	return value;
}

AppConfig.prototype.setConfig = function(key, value, usePreferences) {
	if(typeof usePreferences === 'undefined') usePreferences = true;

	var _key = key;
	PGLocalStorage.setVal(_key, value);
	if (usePreferences) {
		PGConfig.putStr(_key, value);
		PGLog.write("appConfig/setConfig:" + _key + " / " + value);
	}
}

AppConfig.prototype.deleteConfig = function(key, usePreferences) {
	if(typeof usePreferences === 'undefined') usePreferences = true;

	PGLocalStorage.remove(key);
	if (usePreferences) {
		PGConfig.remove(key);
	}
}

if (appConfig == null) {
	var appConfig = new AppConfig;
}