/**
 * ブラウザからのイベント
 */
var PGEventListener = (function() {
	var axi_content = null;
	
	return {
		createMessageListener: function () {
		    return createMessageListener();
		},
		createPauseListener: function() {
			return createPauseListener();
		},
		createResumeListener: function() {
			return createResumeListener();
		}
	}
	
	/*
	 * ブラウザからのメッセージを監視する
	 */
	function createMessageListener(){
		
		axi_content = document.getElementById("axi_content");
		
		window.addEventListener('message', function (event) {
			if (event.data == "begin_load_page"){    // event.data　	→　iframeから受け取ったデーター
				// インジケーター表示
				Indicator.beginLoadPage();
			}else{
				var contact = JSON.parse(event.data);
				
				if(contact.type == "set_footer")
				{
					if (contact.footer) {
						var _contact = contact;
						pGLocalHttpd.getDataBeforeCheckServer(decodeURIComponent(contact.footer), function(data){
							_contact.footer = data;
							//フッターを設定
							if(Indicator.nowIndicator == true)
							{
								AppContent.footer_data = _contact;
							}else{
								AppContent.footer_data = null;
								var ft = document.getElementById("footerArea");
								ft.innerHTML = _contact.footer;
								if(_contact.visible)
								{
									document.getElementById('footerArea').style.display = _contact.visible;
								}else{
									document.getElementById('footerArea').style.display = "none";
								}
								axi_content.style.height = window.innerHeight + 1;
								axi_content.style.height = parseInt(window.innerHeight) - (parseInt(document.getElementById("headerArea").clientHeight));
							}
						});
					}
				}else if(contact.type == "set_header"){
					if(contact.header) {
						var _contact = contact;
						pGLocalHttpd.getDataBeforeCheckServer(decodeURIComponent(contact.header), function(data){
							_contact.header = data;
							//フッターを設定
							if(Indicator.nowIndicator == true)
							{
								AppContent.header_data = _contact;
							}else{
								AppContent.header_data = null;
								var hd = document.getElementById("headerArea");
								hd.innerHTML = _contact.header;
								if(_contact.visible)
								{
									document.getElementById('headerArea').style.display = _contact.visible;
								}else{
									document.getElementById('headerArea').style.display = "none";
								}
								if(document.getElementById("headerArea").style.display == "none")
								{
									axi_content.style.top = 0;
								}else{
									axi_content.style.top = 46;
								}
								axi_content.style.height = window.innerHeight + 1;
								axi_content.style.height = parseInt(window.innerHeight) - (parseInt(document.getElementById("headerArea").clientHeight) );
							}
						});
					}
				}else if(contact.type == "change_stamina_notification_config"){
					var notification_setting = contact.notification_setting;
					
					PGLog.write("notification_setting : " + notification_setting);
					
					if(notification_setting > 0){
						// ローカル通知許可
						PGLocalStorage.setVal('stamina_local_notification'	,	true );
					}else{
						// ローカル通知不可
						PGLocalStorage.setVal('stamina_local_notification'	,	false );
						
						// 登録した通知イベントをキャンセルする
						PGLocalNotification.cancel(contact.stamina_notice_id);
					}
					
				}else if(contact.type == "change_musou_notification_config"){
					var notification_setting = contact.notification_setting;
					
					PGLog.write("notification_setting : " + notification_setting);
					
					if(notification_setting > 0){
						// ローカル通知許可
						PGLocalStorage.setVal('musou_local_notification'	,	true );
					}else{
						// ローカル通知不可
						PGLocalStorage.setVal('musou_local_notification'	,	false );
						
						// 登録した通知イベントをキャンセルする
						PGLocalNotification.cancel(contact.musou_notice_id);
					}
					
				}else if(contact.type == "set_notification"){
					//通知が許可されているかを取得 (こちらの設定はサーバー側と同じ設定)
					var isStaminaNotify = PGLocalStorage.getVal('stamina_local_notification');
					var isMusouNotify = PGLocalStorage.getVal('musou_local_notification');
					
					PGLog.write("set_notification.isStaminaNotify : " + isStaminaNotify);
					PGLog.write("set_notification.isMusouNotify : " + isMusouNotify);
					
					if(((isStaminaNotify == "true") && (contact.nid == 200)) || ((isMusouNotify == "true") && (contact.nid == 201))){
						PGLocalNotification.cancel(contact.nid);
						//timeが0以下なら通知キャンセルするだけ。
						//あまりに短い時間の登録を制限するなら、ここでしきい値を設定する
						if(contact.time > 0){
							PGLocalNotification.local_regist(contact);
						}
					}
					
				}else if(contact.type == "open_popup_window"){
					//ステータスウィンドウ表示
					if(Indicator.nowIndicator == true)
					{
						AppContent.popup_reserve = contact.url;
					}else{
						Popup.open_window(contact.url);
					}
					
				}else if(contact.type == "change_bgm"){
					
	    		}else if(contact.type == "call_relogin_app"){
					// ログイン導線へ遷移
					App.onAppInitialize();
				}else if(contact.type == "app_regist"){
					PGLog.write("user name:" + contact.user_name + "/invite_code:" + contact.invite_code);
			        AppLogin.recordLoginInfo(contact.user_name,contact.invite_code);
					
				}else if(contact.type == "app_regist_bridge"){
					// 本登録
					var gameid = contact.gameid;
					var device_uuid = PGLocalStorage.getVal('device_uuid');
					var platform_typeId = PGLocalStorage.getVal('platform_typeId');
					var bridge_support_url = PGLocalStorage.getVal('bridge_support_url');
					var url = bridge_support_url+gameid+"/reg/top?UUID="+device_uuid+"&type="+platform_typeId;
					PGLog.write(url);
					//window.open( url , "_system" );
					window.open( url , "_blank" , "location=yes,closebuttoncaption=閉じる" );
				}else if(contact.type == "app_update_bridge"){
					// 引き継ぎ
					// uuid発行 (改修が必要、今後UUID発行はサーバー側でやる)
					// var device_uuid = uuid.v1();
					var device_uuid = PGLocalStorage.getVal('device_uuid');
					if (device_uuid == null) {
						// 取得できなかった時の保険処理
						AppLogin.loginEntry();
						device_uuid = PGLocalStorage.getVal('device_uuid');
						// SharedPreferencesに保存
						PGConfig.putStr('device_uuid',device_uuid);
						PGLocalStorage.setVal('device_uuid',device_uuid);
					}

					var gameid = contact.gameid;
					var platform_typeId = PGLocalStorage.getVal('platform_typeId');
					var bridge_support_url = PGLocalStorage.getVal('bridge_support_url');
					var url = bridge_support_url+gameid+"/update/top?UUID="+device_uuid+"&type="+platform_typeId;

					PGLog.write(url);
					//window.open( url , "_system" );
					var windown_ref = window.open( url , "_blank" , "location=yes,closebuttoncaption=閉じる" );
					windown_ref.addEventListener('exit', function(event) {
																			AppLogin.getBridgeUserInfo();	
																		});
				}else if(contact.type == "app_outer_site"){
					var url = contact.url;
					PGLog.write('loadstart:' + url);
					var inquiryWindow = window.open( url , "_blank" , "location=yes,closebuttoncaption=閉じる" );
				}else if(contact.type == "voice_play"){
					/* 2014/11/20 k.sagane 仕様変更に伴いomit
					var my_media = new Media(contact.url,
						function () {
							PGLog.write("playAudio():Audio Success");
						},
						function (err) {
							PGLog.write("playAudio():Audio Error: " + err);
						}
					);
	
					// Play audio
					my_media.play();
					*/
				}
	    	}
		}, false);
	}
	
	function createPauseListener(){
		document.addEventListener('pause', function(){
			soundManager.autoPause();
		}, false);
	}
	
	function createResumeListener(){
		document.addEventListener('resume', function(){
			soundManager.autoResume();
		}, false);
	}

})();

