var MetapsAnalytics = (function () {
	return {
		trackAppInstallEvent: function () {
			return trackAppInstallEvent();
		},
		trackTutorialFinishEvent: function () {
			return trackTutorialFinishEvent();
		},
		trackLv10Event: function () {
			return trackLv10Event();
		},
		trackPurchaselEvent: function (productId) {
			return trackPurchaselEvent(productId);
		},
	}
	
	/**
	 * アプリインストール計測
	 */
	function trackAppInstallEvent() {
		var sdk_environment = PGLocalStorage.getVal('sdk_environment');
		PGLog.write("****** Track application install event");
		PGLog.write("sdk_environment : " + sdk_environment);
		
		if(sdk_environment == 'production'){
			// Call track event
			cordova.exec(
				function (params) {
					// なんもしなくてもいい
					PGLog.write("******* trackAppStartEvent : success");
				},
				function (errs) {
					// なんもしなくてもいい
					PGLog.write("trackAppStartEvent : fail");
				},
				"metapsAnalytics",
				"trackEvent",
				['Track-Event', 'installation', 1] // send params
			);
		}
	}
	
	/**
	 * アプリ起動計測
	 */
	function trackTutorialFinishEvent() {
		var sdk_environment = PGLocalStorage.getVal('sdk_environment');
		PGLog.write("****** Track tutorial finish event");
		PGLog.write("sdk_environment : " + sdk_environment);
		
		if(sdk_environment == 'production'){
			// Call track event
			cordova.exec(
				function (params) {
					// なんもしなくてもいい
					PGLog.write("******* trackTutorialFinishEvent : success");
				},
				function (errs) {
					// なんもしなくてもいい
					PGLog.write("trackTutorialFinishEvent : fail");
				},
				"metapsAnalytics",
				"trackEvent",
				['Track-Event', 'tutorial-breakthrough', 1] // send params
			);
		}
	}
	
	/**
	 * レベル１０突破計測
	 */
	function trackLv10Event() {
		var sdk_environment = PGLocalStorage.getVal('sdk_environment');
		PGLog.write("****** Track Lv10 event");
		PGLog.write("sdk_environment : " + sdk_environment);
		
		if(sdk_environment == 'production'){
			// Call track event
			cordova.exec(
				function (params) {
					// なんもしなくてもいい
					PGLog.write("******* Track Lv10 Event : success");
				},
				function (errs) {
					// なんもしなくてもいい
					PGLog.write("Track Lv10 Event : fail");
				},
				"metapsAnalytics",
				"trackEvent",
				['Track-Event', 'reach-level-10', 1] // send params
			);
		}
	}
	
	/**
	 * 課金計測
	 */
	function trackPurchaselEvent(productId) {
		var sdk_environment = PGLocalStorage.getVal('sdk_environment');
		PGLog.write("****** Track item purchase event");
		PGLog.write("sdk_environment : " + sdk_environment);
		
		if((productId !== null) && (sdk_environment == 'production')){
			var makers = productId.split('.');
			var price = makers[4];
			PGLog.write("Product price : " + price);
			
			// Call track event
			cordova.exec(
				function (params) {
					// なんもしなくてもいい
					PGLog.write("******* TrackItemPurchaseEvent : success");
				},
				function (errs) {
					// なんもしなくてもいい
					PGLog.write("TrackItemPurchaseEvent : fail");
				},
				"metapsAnalytics",
				"trackPurchase",
				[productId, price, 'JPY'] // send params
			);
		}
	}

})();