var PG_Dialog = (function () {
	// public Function
	return {
		open_dialog: function (resultCallback, msg, title, btns) {
			return open_dialog(resultCallback, msg, title, btns);
		},
		dialogGetContentFail: function () {
			return dialogGetContentFail();
		},
		dialogLoginFail: function () {
			return dialogLoginFail();
		},
		dialogAppInitFail: function () {
			return dialogAppInitFail();
		},
		dialogGetProductInfoFail: function () {
			return dialogGetProductInfoFail();
		},
		dialogUserAgeCertificationFail: function () {
			return dialogUserAgeCertificationFail();
		},
		dialogInitBillingPluginFail: function () {
			return dialogInitBillingPluginFail();
		}
	};

	/**
	 *    ダイアログが開く
	 */
	function open_dialog(resultCallback, msg, title, btns) {

		cordova.exec(
			resultCallback,
			function (errs) {
				PGLog.write("Fail to dialog open notification");
			},
			"Notification",
			"confirm",
			[msg, title, btns] // ボタンは右からでる
		);

	}

	/**
	 * リロードor終了ダイアログを表示
	 *
	 * @param msg
	 * @param title
	 * @param btns
	 */
	function dialogReloadOrExit(msg, title, btns) {
		var resultCallBack = function (buttonIndex) {
			if (buttonIndex == 2) {
				navigator.app.exitApp();
			} else {
				//location.reload();
				location.href = "index.html";
			}
		};
		open_dialog(resultCallBack, msg, title, btns);
	}

	/**
	 * ウィンドウクローズor終了ダイアログを表示
	 *
	 * @param msg
	 * @param title
	 * @param btns
	 */
	function dialogCloseOrExit(msg, title, btns) {
		var resultCallBack = function (buttonIndex) {
			if (buttonIndex == 2) {
				navigator.app.exitApp();
			} else {
				Popup.window_close();
			}
		};
		open_dialog(resultCallBack, msg, title, btns);
	}

	/**
	 * コンテンツ取得エラーダイアログ
	 */
	function dialogGetContentFail() {
		dialogReloadOrExit("通信に失敗しました。\n再接続しますか。", "通信エラー", ["再接続", "終了"]);
	}

	/**
	 * ログインエラーダイアログ
	 */
	function dialogLoginFail() {
		dialogReloadOrExit("ログインに失敗しました。\n再接続しますか。", "通信エラー", ["再接続", "終了"]);
	}

	/**
	 * アプリケーション初期化エラーダイアログ
	 */
	function dialogAppInitFail() {
		dialogReloadOrExit("アプリケーションの初期化に失敗しました。\n再接続しますか。", "起動エラー", ["再接続", "終了"]);
	}

	/**
	 * 商品情報取得エラーダイアログ
	 */
	function dialogGetProductInfoFail() {
		dialogCloseOrExit("商品情報の取得に失敗しました。\n通信状況をご確認の上、再度お試しください。", "通信エラー", ["閉じる", "終了"]);
	}

	/**
	 * ユーザ生年月認証エラーダイアログ
	 */
	function dialogUserAgeCertificationFail() {
		dialogCloseOrExit("生年月認証に失敗しました。\n少し時間を空けてから、再度お試しください。", "認証エラー", ["閉じる", "終了"]);
	}

	/**
	 * 課金プラグイン初期化エラーダイアログ
	 */
	function dialogInitBillingPluginFail() {
		dialogCloseOrExit("Google認証に失敗しました。\nご登録されているGoogleアカウントの状況をご確認の上、再度お試しください。", "認証エラー", ["閉じる", "終了"]);
	}

})();
