/*
 *　LocalStorageに保存する。基本的に、この保存方法はブラウザに保存しますので、永久に格納することを保証しません。
 * 　5MBしか保存できないので、扱いときにご注意ください
 * 情報取得 -> PGLocalStorage.getVal(key);
 *
 *  管理のため、全部の変数名をこちらに記入してください
 *　　	通知の送信者ID　				-> gcm_sender_id
 *　　	【認証】UUID					-> device_uuid
 *		アプリの接続先URL 				-> axi_server_url
 *		Bridge Api URL 				-> bridge_api_endpoint
 *		preferencesファイル名			-> preferences_version
 * 		初回起動フラグ					-> is_first_login
 *		課金コールバックURL				-> callback_from
 *		課金機能でresume処理を飛ばす		-> start_buy_coin
 *　　	
*/
var PGLocalStorage = (function() {

	// public Function
	return {
		setVal: function (key, val, disableEncode) {
			if(typeof disableEncode === 'undefined') {
				if (val != null) val = decEnc.getEncryptedJsonString(val);
			}
			return window.localStorage.setItem(key,val);
		},
		getVal: function (key, disableEncode) {
			var val = window.localStorage.getItem(key);
			if(typeof disableEncode === 'undefined') {
				if (val != null) val = decEnc.getDecryptedString(val);
			}
			return val;
		},
		remove: function (key) {
			return window.localStorage.removeItem(key);
		},
		clearAll: function (excludeList) {
			// 退避指定がなければ問答無用で全削除
			if (!Array.isArray(excludeList)) return window.localStorage.clear();

			var tmpRecords = {};
			for(var i = 0; i < excludeList.length; i++) {
				tmpRecords[excludeList[i]] = window.localStorage.getItem(excludeList[i]);
			}
			this.clearAll();
			for(var key in tmpRecords) {
				window.localStorage.setItem(key, tmpRecords[key]);
			}

			return true;
		}

	}

})();
