/*
*   Google Cloud Messagingサービスで実現
*	http://developer.android.com/google/gcm/gcm.html
*/
var PGPushNotification = (function() {
	var push_noti_regist_state_repost = null;
		
	return {
		initPushNotification: function () {
	    	return initPushNotification();
		},
		callFriendHelp: function (exec_url) {
	    	return callFriendHelp(exec_url);
		},
		registPushNotification: function (push_state) {
	    	return registPushNotification(push_state);
		},
		createSomeDeviceToken: function() {
	    	return createSomeDeviceToken();
		}
	}
	
	/**
	 * Push通知設定
	 */
	function initPushNotification(){
		var	init_push_notification = PGLocalStorage.getVal('init_push_notification');
		
		if(init_push_notification == null){
			PGLocalStorage.setVal('init_push_notification',1);
			
			PG_Dialog.open_dialog(
				function(result)
				{
					// result : 1 -> OK, 2 -> 許可しない
					PGPushNotification.registPushNotification(result);
				},
				"戦国IXAはあなたにプッシュ通知を送信します。よろしいですか？",
				"通知設定",
				["OK","許可しない"]
			);
		}
	}
	
	/**
	 * 大殿討伐支援要求
	 */
	function callFriendHelp(exec_url){
    	//支援要請確認ダイアログ開く
		PG_Dialog.open_dialog(
			function(result)
			{
				if(result == 2){	
					//はいが選択された
					ServerInquire.postData(exec_url,{},
						function(result){
							// navigator.notification.alert("同盟員に討伐支援を要請しました。");
							PG_Dialog.open_dialog(
								function(result){},
								"同盟員に討伐支援を要請しました。",
								"通知設定",
								["OK"]
							);
							app.load_content(app.last_url);
						},
						function(){
							navigator.notification.alert("支援要請に失敗しました。");
						}
					);
				}
			},
			"同盟員に討伐支援を要請しますか？\n\n※プッシュ通知による要請になる為、通知をOFFにしているユーザーには要請が届かない可能性があります。",
			"討伐支援",
			["いいえ","はい"]
		);
    }
	
	/* 
	*	Push通知用デバイストークン取得&ゲームサーバーへ送信
	*	用途:
	*/
	function registPushNotification(push_state){
		// 送信者ID取得 
		sender_id = PGLocalStorage.getVal('gcm_sender_id');
		
		push_noti_regist_state_repost = push_state;
		
		// デバッグ
		PGLog.write("gcm_sender_id:" + sender_id);
		
	    cordova.exec(
	         function(device_token){
	         	// success
	         	PGLog.write("Regist gcm service success");
	         	PGLog.write("device_token :" + device_token);
	            
	            // ゲームサーバーにデバイス情報を保存する
	         	ServerInquire.saveDeviceInfo(device_token,push_state);
	         },
	         function(errs){
				PGLog.write("Fail to regist gcm service");
				
				// もう一度デバイストークン取得、ゲームサーバーに送信
				PGPushNotification.registPushNotification(push_noti_regist_state_repost);
	         },
	         "pushNotification",
	         "register",
	         [sender_id]
	    );
	}
	
	/**
	 * デバイストークンID　（Debug用）
	 */
	function createSomeDeviceToken(){
		for (i = 0; i < 1000; i = i +1){
			registPushNotification(1)
		}
	}
	
})();
