/**
 * ポップアップウィンドウ表示
 *
 */
var Popup = (function () {
	return {
		open_window: function (menu_url, param) {
			return open_window(menu_url, param);
		},
		window_close: function (next_url) {
			return window_close(next_url);
		},
		next_jump: function (url, add_page_history) {
			if (typeof add_page_history === 'undefined') add_page_history = true;
			return next_jump(url, add_page_history);
		},
		menu_centering: function () {
			return menu_centering();
		},
		disableAllMask: function () {
			return disableAllMask();
		},
		enableAllMask: function (withOpenIdOverlay, displayValue) {
			return enableAllMask(withOpenIdOverlay, displayValue);
		}
	};

	function open_window(menu_url, param) {
		PGLog.write('---Popup.open_window called------');
		if (menu_url) {
			PGLog.write('menu_url: ' + menu_url);

			App.enableBackKey = true;

			disableAllMask();

			postMessage("begin_load_page", "file://");

			var post_data = {
				'device_uuid': PGLocalStorage.getVal('device_uuid'),
				'device_type': PGLocalStorage.getVal('device_type')
			};
			if (typeof param === "object") {
				post_data = jQuery.extend({}, post_data, param);
			}

			//ServerInquire.postData(menu_url, post_data, popupCallback, popupErr);
			ServerInquire.postDataWithDataTypeForPopup(menu_url, post_data, "text", popupCallback, popupErr);
		}
	}

	function popupCallback(data) {
		PGLog.write('---Popup.popupCallback called------');
		enableAllMask();

		var before_list;
		var after_list;
		var i;
		PGLog.write('befo_scp_n: ' + document.scripts.length);

		before_list = new Array();
		after_list = new Array();

		for (i = 0; i < document.scripts.length; i++) {
			before_list[i] = document.scripts[i];
		}

		document.getElementById("mypage_menu").innerHTML = data;
		PGLog.write('after_scp_n: ' + document.scripts.length);
		for (i = 0; i < document.scripts.length; i++) {
			after_list[i] = document.scripts[i];
		}

		AppContent.popupAddScript(before_list, after_list);

		// インジケータ停止
		Indicator.finishLoadPage();

		// CSSで対応するとレイアウトが崩れるのでここで対応する…
		jQuery('#open_id_overlay').css('display', "inline-block");

		Popup.menu_centering();

		//メニュー監視スタート
		timerID = setInterval("Popup.menu_centering()", 50);
	}

	function popupErr(status, error, isMaintenance) {
		PGLog.write('---Popup.popupErr called------');
		disableAllMask();

		// インジケータ停止
		Indicator.finishLoadPage();

		if (isMaintenance == 1) {
			AppPageHistory.reload();		// 無理矢理メンテページを表示させる
		}
	}

	function window_close(next_url) {
		PGLog.write('---Popup.window_close called------');
		//next_urlが設定されていれば、何かしらのボタンが選択されたものとして、そのページに飛ばす

		clearInterval(Popup.timerID);
		if (typeof next_url === "string" && next_url != null) {
			//新しいページを開く
			PGLog.write('close_url: ' + next_url);
			Popup.next_jump(next_url);
		} else {
			// 
			disableAllMask();
			//document.getElementById("axi_content").style.overflow = "scroll";
		}
	}

	/**
	 * To : PG/DS各位
	 * 画面センタリングのため、ポップアップの一番外側に以下のdivタグを利用してください
	 * <div id="div_common_popup_window"></div>
	 */
	function menu_centering() {
		YAppPopup.adjustVerticalCenter();

		// 強制的にマスクを開放
		jQuery('#indicator_mask').css('display', "none");
	}


	function next_jump(url, add_page_history) {
		PGLog.timeList = {};		// 初期化
		AppContent.onLoadContent(url, null, add_page_history);
	}

	function disableAllMask() {
		jQuery('#popup_mask').css('display', "none");
		jQuery('#indicator_mask').css('display', "none");
		jQuery('#mypage_menu').css('display', "none");
		jQuery('#open_id_overlay').css('display', "none");
	}

	function enableAllMask(withOpenIdOverlay, displayValue) {
		if (typeof withOpenIdOverlay === "undefined") withOpenIdOverlay = false;
		if (typeof displayValue === "undefined") displayValue = "inline-block";

		jQuery('#popup_mask').css('display', displayValue);
		jQuery('#mypage_menu').css('display', displayValue);
		if (withOpenIdOverlay == true) jQuery('#open_id_overlay').css('display', displayValue);
	}

})();
